Debian Bug report logs - #521260
iodined: segfaults when client connects

version graph

Package: iodine; Maintainer for iodine is gregor herrmann <gregoa@debian.org>; Source for iodine is src:iodine.

Reported by: martin f krafft <madduck@debian.org>

Date: Thu, 26 Mar 2009 09:36:02 UTC

Severity: important

Found in version iodine/0.4.2-1

Fixed in versions iodine/0.5.1-2, 0.5.1-2~bpo50+1

Done: gregor herrmann <gregoa@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, gregor herrmann <gregoa@debian.org>:
Bug#521260; Package iodine. (Thu, 26 Mar 2009 09:36:07 GMT) Full text and rfc822 format available.

Acknowledgement sent to martin f krafft <madduck@debian.org>:
New Bug report received and forwarded. Copy sent to gregor herrmann <gregoa@debian.org>. (Thu, 26 Mar 2009 09:36:27 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: iodined: segfaults when client connects
Date: Thu, 26 Mar 2009 10:32:42 +0100
[Message part 1 (text/plain, inline)]
Package: iodine
Version: 0.4.2-1
Severity: important

When iodined starts

  iodined -f -DDD -u iodine -t /var/run/iodine -P foo -l
  130.60.75.73 192.168.254.245 r.neokon.ch

and a client connects, iodined segfaults. strace is attached. I can
reproduce at will but don't really know what other info to provide
right now.

-- System Information:
Debian Release: squeeze/sid
  APT prefers unstable
  APT policy: (500, 'unstable'), (500, 'stable'), (1, 'experimental')
Architecture: i386 (i686)

Kernel: Linux 2.6.28-1-686 (SMP w/1 CPU core)
Locale: LANG=en_GB, LC_CTYPE=en_GB.UTF-8 (charmap=UTF-8)
Shell: /bin/sh linked to /bin/dash

Versions of packages iodine depends on:
ii  adduser                3.110             add and remove users and groups
ii  debconf [debconf-2.0]  1.5.26            Debian configuration management sy
ii  libc6                  2.9-6             GNU C Library: Shared libraries
ii  makedev                2.3.1-88          creates device files in /dev
ii  udev                   0.125-7           /dev/ and hotplug management daemo
ii  zlib1g                 1:1.2.3.3.dfsg-13 compression library - runtime

iodine recommends no packages.

Versions of packages iodine suggests:
ii  dnsutils               1:9.5.1.dfsg.P2-1 Clients provided with BIND
ii  fping                  2.4b2-to-ipv6-16  sends ICMP ECHO_REQUEST packets to
ii  gawk                   1:3.1.5.dfsg-4.1  GNU awk, a pattern scanning and pr
ii  ipcalc                 0.41-1            parameter calculator for IPv4 addr
ii  iproute                20090115-1        networking and traffic control too

-- debconf information excluded


-- 
 .''`.   martin f. krafft <madduck@d.o>      Related projects:
: :'  :  proud Debian developer               http://debiansystem.info
`. `'`   http://people.debian.org/~madduck    http://vcs-pkg.org
  `-  Debian - when you have better things to do than fixing systems
[iodined.strace.bz2 (application/octet-stream, attachment)]
[digital_signature_gpg.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#521260; Package iodine. (Thu, 26 Mar 2009 16:30:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. (Thu, 26 Mar 2009 16:30:03 GMT) Full text and rfc822 format available.

Message #10 received at 521260@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: martin f krafft <madduck@debian.org>, 521260@bugs.debian.org
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Thu, 26 Mar 2009 17:12:37 +0100
[Message part 1 (text/plain, inline)]
On Thu, 26 Mar 2009 10:32:42 +0100, martin f krafft wrote:

> When iodined starts
> 
>   iodined -f -DDD -u iodine -t /var/run/iodine -P foo -l
>   130.60.75.73 192.168.254.245 r.neokon.ch
> 
> and a client connects, iodined segfaults. strace is attached. I can
> reproduce at will but don't really know what other info to provide
> right now.

Thanks for the bug report, and that's indeed nasty.

My suspicion is that you are running an iodine 5.x client against an
iodined 4.x server -- is that true?

I tried now by starting the 0.4.2 server and connecting with the 0.5.1
client, and the result looks looks yours:

[..]
select(5, [4], NULL, NULL, {1, 0})      = 1 (in [4], left {0, 920000})
recvfrom(4, "\374\226\0\0\0\1\0\0\0\0\0\0\vVaaaakaaaaa\6tunnel\6c"..., 65536, 0, {sa_family=AF_INET, sin_port=htons(59285), sin_addr=inet_addr("195.34.133.10")}, [16]) = 51
--- SIGSEGV (Segmentation fault) @ 0 (0) ---

(With the 0.5.1 client against the 0.5.1 server evreything is fine.)


I'm not surprised that the protocols are not compatible but what
suprises me is
* that I don't find the documentation for the behaviour at the moment
  (ok, later I saw in my svn log that I added and removed in in/from
  README.Debian but forgot about it with the 5.x release)
* that the client doesn't spit out a warning although there are some
  lines in the code that check the protocol versions. Ok, the server
  probably segfaults _before_

Could you please
* check if my suspicion with the protocol discrepancy is true?
* maybe try with a 5.x version on the server?

I will add the note to README.Debian again, and I can also create a
backport package after the package I'm going to upload later hits
testing.

Any other ideas?


Cheers,
gregor

-- 
 .''`.   Home: http://info.comodo.priv.at/{,blog/} / GPG Key ID: 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT, SPI Inc., fellow of FSFE | http://got.to/quote/
   `-    NP: U2: Unchained Melody (live bootleg
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, gregor herrmann <gregoa@debian.org>:
Bug#521260; Package iodine. (Fri, 27 Mar 2009 09:18:08 GMT) Full text and rfc822 format available.

Acknowledgement sent to martin f krafft <madduck@debian.org>:
Extra info received and forwarded to list. Copy sent to gregor herrmann <gregoa@debian.org>. (Fri, 27 Mar 2009 09:18:12 GMT) Full text and rfc822 format available.

Message #15 received at 521260@bugs.debian.org (full text, mbox):

From: martin f krafft <madduck@debian.org>
To: gregor herrmann <gregoa@debian.org>
Cc: 521260@bugs.debian.org
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Fri, 27 Mar 2009 10:11:02 +0100
[Message part 1 (text/plain, inline)]
also sprach gregor herrmann <gregoa@debian.org> [2009.03.26.1712 +0100]:
> My suspicion is that you are running an iodine 5.x client against
> an iodined 4.x server -- is that true?

Yes, good analysis. Silly that I didn't think of it. :)

> * check if my suspicion with the protocol discrepancy is true?
> * maybe try with a 5.x version on the server?

Yeah, it works with a backport.

> I will add the note to README.Debian again, and I can also create a
> backport package after the package I'm going to upload later hits
> testing.

Sweet, thanks,

-- 
 .''`.   martin f. krafft <madduck@d.o>      Related projects:
: :'  :  proud Debian developer               http://debiansystem.info
`. `'`   http://people.debian.org/~madduck    http://vcs-pkg.org
  `-  Debian - when you have better things to do than fixing systems
 
the reason the mainstream is thought of as a stream
is because it is so shallow.
[digital_signature_gpg.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#521260; Package iodine. (Sat, 28 Mar 2009 07:36:05 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. (Sat, 28 Mar 2009 07:36:05 GMT) Full text and rfc822 format available.

Message #20 received at 521260@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: martin f krafft <madduck@debian.org>
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Fri, 27 Mar 2009 22:09:30 +0100
[Message part 1 (text/plain, inline)]
On Fri, 27 Mar 2009 10:11:02 +0100, martin f krafft wrote:

> > My suspicion is that you are running an iodine 5.x client against
> > an iodined 4.x server -- is that true?
> Yes, good analysis. Silly that I didn't think of it. :)

:)
Well, it's not really obvious without clear documentation/error
messages.
 
> > * check if my suspicion with the protocol discrepancy is true?
> > * maybe try with a 5.x version on the server?
> Yeah, it works with a backport.

Great, thanks for checking!
 
> > I will add the note to README.Debian again, and I can also create a
> > backport package after the package I'm going to upload later hits
> > testing.
> Sweet, thanks,

I leave this bug open until the backported package is available. 

Cheers,
gregor 
-- 
 .''`.   Home: http://info.comodo.priv.at/{,blog/} / GPG Key ID: 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT, SPI Inc., fellow of FSFE | http://got.to/quote/
   `-    NP: JBO: K�nige
[signature.asc (application/pgp-signature, inline)]

Information stored :
Bug#521260; Package iodine. (Mon, 06 Apr 2009 16:48:04 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and filed, but not forwarded. (Mon, 06 Apr 2009 16:48:04 GMT) Full text and rfc822 format available.

Message #25 received at 521260-quiet@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: 521260-quiet@bugs.debian.org
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Mon, 6 Apr 2009 18:45:22 +0200
[Message part 1 (text/plain, inline)]
On Fri, 27 Mar 2009 22:09:30 +0100, gregor herrmann wrote:

> > > I will add the note to README.Debian again, and I can also create a
> > > backport package after the package I'm going to upload later hits
> > > testing.
> > Sweet, thanks,
> I leave this bug open until the backported package is available. 

0.5.1-2 is in testing, I'm waiting for my key to be added to the
backports keyring.

Cheers,
gregor
 
-- 
 .''`.   Home: http://info.comodo.priv.at/{,blog/} / GPG Key ID: 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT, SPI Inc., fellow of FSFE | http://got.to/quote/
   `-    NP: The Pogues (with the Dubliners): Whiskey in the Jar
[signature.asc (application/pgp-signature, inline)]

Bug marked as fixed in version 0.5.1-2. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Thu, 09 Apr 2009 14:45:05 GMT) Full text and rfc822 format available.

Bug marked as fixed in version 0.5.1-2~bpo50+1. Request was from gregor herrmann <gregoa@debian.org> to control@bugs.debian.org. (Thu, 09 Apr 2009 14:45:07 GMT) Full text and rfc822 format available.

Reply sent to gregor herrmann <gregoa@debian.org>:
You have taken responsibility. (Thu, 09 Apr 2009 14:45:10 GMT) Full text and rfc822 format available.

Notification sent to martin f krafft <madduck@debian.org>:
Bug acknowledged by developer. (Thu, 09 Apr 2009 14:45:10 GMT) Full text and rfc822 format available.

Message #34 received at 521260-done@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: 521260-done@bugs.debian.org
Cc: control@bugs.debian.org
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Thu, 9 Apr 2009 16:41:16 +0200
[Message part 1 (text/plain, inline)]
fixed 521260 0.5.1-2
fixed 521260 0.5.1-2~bpo50+1
thanks

On Mon, 06 Apr 2009 18:45:22 +0200, gregor herrmann wrote:

> > > > I will add the note to README.Debian again, and I can also create a
> > > > backport package after the package I'm going to upload later hits
> > > > testing.
> > > Sweet, thanks,
> > I leave this bug open until the backported package is available. 
> 0.5.1-2 is in testing, I'm waiting for my key to be added to the
> backports keyring.

0.5.1-2 (jn testing) contains the note in the changelog,
0.5.1-2~bpo50+1 is uploaded to and accepted in lenny-backports,
therefore I'm closing this bug.

Cheers,
gregor
 
-- 
 .''`.   Home: http://info.comodo.priv.at/{,blog/} / GPG Key ID: 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT, SPI Inc., fellow of FSFE | http://got.to/quote/
   `-    NP: Der Junge mit der Gitarre: Der Lehrer kommt
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, gregor herrmann <gregoa@debian.org>:
Bug#521260; Package iodine. (Sun, 26 Apr 2009 11:09:02 GMT) Full text and rfc822 format available.

Acknowledgement sent to Albert Sellarès <whats@wekk.net>:
Extra info received and forwarded to list. Copy sent to gregor herrmann <gregoa@debian.org>. (Sun, 26 Apr 2009 11:09:02 GMT) Full text and rfc822 format available.

Message #39 received at 521260@bugs.debian.org (full text, mbox):

From: Albert Sellarès <whats@wekk.net>
To: 521260@bugs.debian.org
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Sun, 26 Apr 2009 13:05:20 +0200
[Message part 1 (text/plain, inline)]
Hi,

I just found the same bug while I was trying to connect to the iodined
from a debian stable using the iodine client from the source code
(version 0.5.1).

I have seen in the code, that it checks the version number, but it isn't
done correctly. I know that the last version of this code have solved
this issue, but the current version in debian stable has this bug, and
it is very dangerous.

I attach a patch that solves the segmentation fault.

Greetings.
-- 
  Albert Sellarès        GPG id: 0x13053FFE
  http://www.wekk.net    whats@jabber.org 
  Linux User: 324456                
[iodined.patch (text/x-patch, attachment)]
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#521260; Package iodine. (Sun, 26 Apr 2009 18:30:06 GMT) Full text and rfc822 format available.

Acknowledgement sent to gregor herrmann <gregoa@debian.org>:
Extra info received and forwarded to list. (Sun, 26 Apr 2009 18:30:06 GMT) Full text and rfc822 format available.

Message #44 received at 521260@bugs.debian.org (full text, mbox):

From: gregor herrmann <gregoa@debian.org>
To: Albert Sellarès <whats@wekk.net>, 521260@bugs.debian.org
Subject: Re: Bug#521260: iodined: segfaults when client connects
Date: Sun, 26 Apr 2009 20:28:37 +0200
[Message part 1 (text/plain, inline)]
On Sun, 26 Apr 2009 13:05:20 +0200, Albert Sellarès wrote:

> I have seen in the code, that it checks the version number, but it isn't
> done correctly. I know that the last version of this code have solved
> this issue, but the current version in debian stable has this bug, and
> it is very dangerous.
> I attach a patch that solves the segmentation fault.

Thanks for your mail and the patch!

I agree that this bug is annoying but I don't see it's a valid reason
for an update in stable (point releases for stable contain only
security relevant fixes and sometimes fixes for grave bugs).

In case you haven't seen it yet, I've created a backport of 5.1.2 for
lenny, it's avaliable at http://backports.org/
May I suggest that you use this version?


Cheers,
gregor 
-- 
 .''`.   Home: http://info.comodo.priv.at/{,blog/} / GPG Key ID: 0x00F3CFE4
 : :' :  Debian GNU/Linux user, admin, & developer - http://www.debian.org/
 `. `'   Member of VIBE!AT, SPI Inc., fellow of FSFE | http://got.to/quote/
   `-    NP: James Taylor: Country Road
[signature.asc (application/pgp-signature, inline)]

Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Mon, 25 May 2009 07:36:58 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Thu Apr 24 23:08:49 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.